using System;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using Decal.Interop.Core;

namespace Decal.Adapter;

[ComImport]
[InterfaceType(1)]
[Guid("DA98635C-A312-463B-A746-2CF62AF7413A")]
internal interface IAdapterSurrogate
{
	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	IntPtr CreateInstance([MarshalAs(UnmanagedType.Interface)] DecalEnum pInitData, ref Guid riid);

	[DispId(1610678273)]
	string Version
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		[return: MarshalAs(UnmanagedType.BStr)]
		get;
	}

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	void SetEnum([MarshalAs(UnmanagedType.Interface)] DecalEnum pInitData);

	[DispId(1610678275)]
	bool FileExists
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		get;
	}

	[DispId(1610678276)]
	string FilePath
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		[return: MarshalAs(UnmanagedType.BStr)]
		get;
	}
}
